ColNumb         equ     136               ;136 sumbols on one row
UniqueCode_F1   equ     0de07h            ;Unique code for int 2Fh
UniqueCode_F2   equ     0de08h            ;Unique code for int 2Fh

code            segment
                assume  cs:code,es:code,ds:code
                org     100h
start:          jmp     End_Resident
                org     110h
OldInt2F        dd      0                      ; Old handlers'vectors.
OldInt17        dd      0
SymbonRowWord    label   word                  ;Number of symbols on current row
SymbOnRow       db      0
                db      0
ColNext         dw      OFFSET RowBuff         ;Pointer in row buffer
RowBuff         db      ColNumb+1 dup (0)      ;Line /Row/ buffer
Row2Buff        db      ColNumb+1 dup (0)      ;Line spacing buffer /for ,,/
FlagRow2        db      0                      ;Is there printing between rows /in line spacing/
ColNext2         dw      OFFSET Row2Buff

I17_Handler     proc                           ;Int 17h handler.
                sti
                cld
                cmp     ah,0
                je      GoWork
                jmp     dword ptr cs:OldInt17
GoWork:
                call    MoveInBuff             ;Move sumbol on row buffer
                cmp     al,0dh
                je      PrintLine              ;Go print line /row/
                cmp     al,0ah                 ; just after 0Dh /CR/ or 0Ah /LF/
                jne     EndWork
PrintLine:
                push    ds
                push    si
                push    cx
                push    cs
                pop     ds
                mov     si,offset RowBuff
                mov     cx,cs:SymbOnRowWord     ;Check if there are some symbols
                cmp     cx,0                    ; on row. /Optimizing/
                je      Just0Aor0D
                call    Send_Gr_Inf             ;Send NumbSymbOnRow*12 to printer
AllRow:         lodsb
                call    BuildCode               ;Send 12 bytes for each symbol
                loop    AllRow
                cmp     cs:FlagRow2,1           ;If it's necesary print line spacing
                jne     Just0Aor0D
                call    ShowRow2
Just0Aor0D:     lodsb
                call    SendByte                ; Send byte to printer
                cmp     al,0ah
                jne     InitPrg
                mov     al,1bh                  ;Reestablish line spasing heigth
                call    SendByte                ;
                mov     al,33h                  ;
                call    SendByte                ;
                mov     al,36                   ;
                call    SendByte                ;
InitPrg:        mov     cs:ColNext2,OFFSET Row2Buff   ;Init variables. They
                mov     cs:FlagRow2,0                 ; must be ready for
                mov     cs:ColNext,OFFSET RowBuff     ; next row.
                mov     cs:SymbOnRow,0                ;
                pop     cx
                pop     si
                pop     ds
EndWork:        iret
I17_Handler     endp
                                                         ;Show line spacing
ShowRow2        proc                                     ;Decreese line
                mov     si,offset Half13Row              ;spacing height
                mov     cx,5
Sl_5:           lodsb
                call    SendByte
                loop    Sl_5
                mov     si,offset Row2Buff               ;Set pointers
                mov     cx,cs:SymbOnRowWord              ;Send Graphics info
                call    Send_Gr_Inf                      ; to printer
AllRow2:        lodsb
                push    si
                push    cx
                mov     si,offset HalfSymbs
                mov     cl,12
                mul     cl
                add     si,ax
                mov     cx,12
AlllCodes2:
                lodsb                              ;They are half symbols
                call    SendByte                   ; between the rows.
                loop    AlllCodes2
                pop     cx
                pop     si
                loop    AllRow2
                push    si
                mov     si,offset Half23Row
                mov     cx,3
Sl_52:          lodsb
                call    SendByte
                loop    Sl_52
                pop     si
                ret
ShowRow2        endp

Half13Row       db      1bh,33h,12,0ah,0dh
Half23Row       db      1bh,33h,24
HalfSymbs       db   000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,0,0
                db   000h,000h,000h,000h,000h,00fh,00fh,000h,000h,000h,0,0
                db   000h,000h,000h,00fh,00fh,000h,000h,00fh,00fh,000h,0,0
                db   005h,000h,000h,000h,005h,000h,000h,000h,005h,000h,0,0
                db   005h,000h,000h,00ah,000h,000h,005h,000h,000h,00ah,0,0
                db   005h,000h,00ah,000h,005h,000h,00ah,000h,005h,000h,0ah,0
                db   00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,0fh,0fh
                db   00fh,00fh,00fh,00fh,00fh,00fh,000h,000h,000h,000h,0,0
                db   000h,000h,000h,000h,000h,000h,00fh,00fh,00fh,00fh,0fh,0fh

BuildCode       proc                             ;For each symbols gets 12
                push    si                       ;bytes from table and
                push    cx                       ;send it to printer.
                mov     si,offset Codes-(32*12)
                mov     cl,12
                mul     cl
                add     si,ax
                mov     cx,12
AlllCodes:
                lodsb
                call    SendByte
                loop    AlllCodes
                pop     cx
                pop     si
                ret
BuildCode       endp

MoveInBuff2     proc                           ;Fill line spacing buffer.
                push    ax                     ;If there are some pseudo
                cmp     al,0dh                 ;graphics symbols fills
                je      MoveAD                 ;line spacing buffer with number
                cmp     al,0ah                 ;in diapazone 0 to 8
                je      MoveAD                 ; 1 - ,,,,,,
                cmp     al,194                 ; 2 - ,,,,,,
                jb      MoveSpace              ; 3 - 
                push    cx                     ; 4 - 
                mov     cx,7                   ; 5 - 
                mov     di,offset Line_I       ; 6 - 
                repne   scasb                  ; 7 - 
                jnz     Check_II               ; 8 - 
                mov     al,1                   ; 0 - each else symbol
                jmp     SetFl
Check_II:       mov     cx,7
;                mov     di,offset Line_II
                repne   scasb
                jnz     Check_M
                mov     al,2
                jmp     SetFl
Check_M:        mov     ah,3
;                mov     di,offset Line_M
                mov     cx,6
Each_BoldS:     scasb
                je      Move_BoldS
                inc     ah
                loop    Each_BoldS
                pop     cx
                jmp     MoveSpace
Move_BoldS:     mov     al,ah
SetFl:          mov     cs:FlagRow2,1
                pop     cx
                jmp     MoveAD
MoveSpace:      mov     al,0
MoveAD:         mov     di,cs:ColNext2
                stosb
                mov     cs:ColNext2,di
                pop     ax
                ret
MoveInBuff2     endp
Line_I          db      194,195,197,207,211,212,218       ;Pseudo-graphics
Line_II         db      198,199,201,203,204,206,215       ;symbols ascii codes
Line_M          db      208,209,210,219,221,222           ;

MoveInBuff      proc
                cmp     al,0dh
                je      Move0Aor0D
                cmp     al,0ah
                je      Move0Aor0D
                cmp     cs:SymbOnRow,ColNumb   ;Check current number of symbols
                ja      CutRow                 ; on line
                inc     cs:SymbOnRow
Move0Aor0D:
                push    es
                push    di                     ;Buffer is 1 line
                push    cs
                pop     es
                mov     di,cs:ColNext
                stosb
                mov     cs:ColNext,di
                call    MoveInBuff2
                pop     di
                pop     es
CutRow:         ret
MoveInBuff      endp

SendByte        proc                            ;Print symbol with ASCII in AL.
                push    ax
                mov     ah,0
                pushf
                call    dword ptr cs:OldInt17
                pop     ax
                ret
SendByte        endp

Send_Gr_Inf     proc                           ;According possebilities
                mov     al,1bh                 ;of printers with graphical
                call    SendByte               ;functions send
                mov     al,4ch                 ;1bh /Esc/ + 4ch + <Numb of colums>
                call    SendByte               ;Each symbol is 12 colums
                mov     ax,12
                mul     cl
                call    SendByte
                mov     al,ah
                call    SendByte
                ret
Send_Gr_Inf     endp

;--------------------Table with 12 bytes for each symbol /graphical info./---------------
Codes   db        0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,  0 ,0,0     ;Space
        db        0 ,  0 ,  0 ,060h,0fdh,0fdh,060h,  0 ,  0 ,  0 ,0,0     ;!
        db        0 ,0a0h,0e0h,0c0h,  0 ,  0 ,0a0h,0e0h,0c0h,  0 ,0,0     ;"
        db      028h,028h,0feh,0feh,028h,028h,0feh,0feh,028h,028h,0,0     ;#
        db      0e6h,0f2h,092h,092h,0feh,0feh,092h,092h,09eh,0cch,0,0     ;$
        db      0c4h,0c4h,0c8h,008h,010h,010h,020h,026h,046h,046h,0,0     ;%
        db       0ch,06eh,092h,092h,092h,06ah,064h, 04h, 0ah, 0ah,0,0     ;&
        db        0 ,  0 ,  0 ,  0 ,0a0h,0e0h,0c0h,  0 ,  0 ,  0 ,0,0     ;'
        db        0 ,  0 ,038h,044h,044h,082h,082h,082h,  0 ,  0 ,0,0     ;(
        db        0 ,  0 ,082h,082h,082h,044h,044h,038h,  0 ,  0 ,0,0     ;)
        db        0 ,010h,054h,038h,0feh,038h,054h,010h,  0 ,  0 ,0,0     ;*
        db      010h,010h,010h,010h,07ch,07ch,010h,010h,010h,010h,0,0     ;+
        db        0 ,  0 ,  0 ,  0 ,  5 ,  7 ,  6 ,  0 ,  0 ,  0 ,0,0     ;,
        db      010h,010h,010h,010h,010h,010h,010h,010h,010h,010h,0,0     ;-
        db        0 ,  0 ,  0 ,  0 ,  6 ,  6 ,  6 ,  0 ,  0 ,  0 ,0,0     ;.
        db        1 ,  3 ,  6 , 0ch,018h,030h,060h,0c0h,080h,  0 ,0,0     ;/
        db      038h,07ch,0c6h,082h,082h,082h,082h,0c6h,07ch,038h,0,0     ;0
        db        0 , 12h, 22h, 42h,0feh,0feh,  2 ,  2 ,  2 ,  0 ,0,0     ;1
        db      08eh,09eh,092h,092h,092h,092h,092h,092h,0f2h,062h,0,0     ;2
        db      082h,082h,082h,092h,092h,092h,092h,092h,06ch,06ch,0,0     ;3
        db      0f0h,0f0h,010h,010h,012h,012h,0feh,0feh,012h,012h,0,0     ;4
        db      0f2h,0f2h,092h,092h,092h,092h,092h,092h,09eh,08ch,0,0     ;5
        db      07ch,0feh,092h,092h,092h,092h,092h,092h,09eh,08ch,0,0     ;6
        db      080h,080h,082h,086h,08ch,098h,0b0h,0e0h,0c0h, 80h,0,0     ;7
        db      00ch,07eh,0f2h,092h,092h,092h,092h,0f2h,07eh,00ch,0,0     ;8
        db      062h,0f2h,092h,092h,092h,092h,092h,092h,0feh,07ch,0,0     ;9
        db        0 ,  0 ,  0 ,  0 , 66h, 66h, 66h,  0 ,  0 ,  0 ,0,0     ;:
        db        0 ,  0 ,  0 ,  0 , 65h, 67h, 66h,  0 ,  0 ,  0 ,0,0     ;;
        db        0 , 10h, 10h, 28h, 28h, 44h, 44h, 82h, 82h,  0 ,0,0     ;<
        db        0 , 28h,028h,028h,028h,028h,028h,028h,028h,  0 ,0,0     ;=
        db        0 , 82h, 82h, 44h, 44h, 28h, 28h, 10h, 10h,  0 ,0,0     ;>
        db      0c0h,080h,080h,080h,0bah,0bah,0a0h,0a0h,0e0h,0e0h,0,0     ;?
        db      07ch,0feh,082h,0bah,0bah,0aah,0aah,0bah,0f8h,07ah,0,0     ;@
        db      01eh,03eh,068h,0c8h,088h,088h,0c8h,068h,03eh,01eh,0,0     ;A
        db      082h,0feh,0feh,092h,092h,092h,092h,0f2h,07eh,00ch,0,0     ;B
        db      07ch,0feh,082h,082h,082h,082h,082h,0c6h,044h,044h,0,0     ;C
        db      082h,082h,0feh,0feh,082h,082h,082h,0c2h,066h,03ch,0,0     ;D
        db      082h,0feh,0feh,092h,092h,092h,092h,082h,0c6h,0c6h,0,0     ;E
        db      082h,0feh,0feh,092h,090h,090h,090h,080h,080h,0c0h,0,0     ;F
        db      07ch,0feh,082h,082h,082h,092h,092h,092h,09eh,09ch,0,0     ;G
        db      0feh,0feh,010h,010h,010h,010h,010h,010h,0feh,0feh,0,0     ;H
        db        0h,  0h,082h,082h,0feh,0feh,082h,082h,  0 ,  0 ,0,0     ;I
        db        4h,  6h,  2 ,  2 ,082h,082h,0feh,0fch,080h,080h,0,0     ;J
        db      082h,0feh,0feh,010h,030h,038h,048h,0cch,086h,  6 ,0,0     ;K
        db      082h,0feh,0feh,082h,  2 ,  2 ,  2 ,  2 ,  2 ,  6 ,0,0     ;L
        db      0feh,0feh,060h,030h,01ch,01ch,030h,060h,0feh,0feh,0,0     ;M
        db      0feh,0feh,040h,060h,030h,018h, 0ch,  2 ,0feh,0feh,0,0     ;N
        db      07ch,0feh,082h,082h,082h,082h,082h,082h,0feh,07ch,0,0     ;O
        db      082h,0feh,0feh,092h,090h,090h,090h,090h,0f0h,070h,0,0     ;P
        db      07ch,0feh,082h,082h,08ah,08eh,086h,086h,0feh,07eh,0,0     ;Q
        db      082h,0feh,0feh,092h,090h,098h,09ch,094h,0f6h,072h,0,0     ;R
        db      0e6h,0f2h,092h,092h,092h,092h,092h,092h,09eh,0cch,0,0     ;S
        db      0c0h,080h,080h,082h,0feh,0feh,082h,080h,080h,0c0h,0,0     ;T
        db      0fch,0feh, 02h, 02h, 02h, 02h, 02h, 02h,0feh,0fch,0,0     ;U
        db      0e0h,0f0h,018h, 0ch,  6 ,  6 , 0ch,018h,0f0h,0e0h,0,0     ;V
        db      0f8h,0fch, 06h, 06h,078h,078h, 06h, 06h,0fch,0f8h,0,0     ;W
        db      082h,082h,0c6h,028h,010h,010h,028h,0c6h,082h,082h,0,0     ;X
        db      080h,080h,0c0h,020h,01eh,01eh,020h,0c0h,080h,080h,0,0     ;Y
        db      086h,086h,08ah,08ah,092h,092h,0a2h,0a2h,0c2h,0c2h,0,0     ;Z
        db        0 ,  0 ,  0 ,0feh,0feh,082h,082h,082h,  0 ,  0 ,0,0     ;[
        db        0 , 80h,0c0h, 60h, 30h, 18h, 0ch,  6 ,  3 ,  1 ,0,0     ;/
        db        0 ,  0 ,  0 ,082h,082h,082h,0feh,0feh,  0 ,  0 ,0,0     ;]
        db        0 ,  0 , 20h, 40h, 80h, 80h, 40h, 20h,  0 ,  0 ,0,0     ;^
        db        1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,  1 ,0,0     ;_
        db        0 ,  0 ,  0 ,  0 ,0c0h,0e0h,0a0h,  0 ,  0 ,  0 ,0,0     ;`
        db      02eh,02eh,02ah,02ah,02ah,02ah,02ah,03eh,03eh,  2h,0,0     ;a
        db      082h,082h,0feh,0feh, 22h, 22h, 22h, 22h, 3eh, 1ch,0,0     ;b
        db       1ch,03eh, 22h, 22h, 22h, 22h, 22h, 22h, 22h, 36h,0,0     ;c
        db       1ch, 3eh, 22h, 22h, 22h, 22h,0feh,0feh, 82h, 82h,0,0     ;d
        db       1ch,03eh, 2ah, 2ah, 2ah, 2ah, 2ah, 2ah, 3ah, 1ah,0,0     ;e
        db       12h, 12h, 7eh,0feh, 92h, 92h, 90h, 90h, 80h, 40h,0,0     ;f
        db       19h, 3dh, 25h, 25h, 25h, 25h, 25h, 25h, 3fh, 1eh,0,0     ;g
        db       82h, 82h,0feh,0feh, 20h, 20h, 20h, 20h, 3eh, 1eh,0,0     ;h
        db        0 ,  0 ,  2 , 22h,0beh,0beh,  2 ,  2 ,  0 ,  0 ,0,0     ;i
        db        0 ,  2 ,  2 ,  1 ,  1 , 23h,0bfh,0beh,  0 ,  0 ,0,0     ;j
        db       82h, 82h,0feh,07eh,  8 ,  8 , 14h, 14h, 22h, 22h,0,0     ;k
        db        0 ,  0 ,  2 , 82h,0feh,0feh,  2 ,  2 ,  0 ,  0 ,0,0     ;l
        db       3eh, 3eh, 10h,  8 ,  4 ,  4 ,  8 , 10h, 3eh, 3eh,0,0     ;m
        db       20h, 20h, 1eh, 3eh, 20h, 20h, 20h, 20h, 3eh, 1eh,0,0     ;n
        db       1ch, 3eh, 22h, 22h, 22h, 22h, 22h, 22h, 3eh, 1ch,0,0     ;o
        db       21h,03fh,03fh, 24h, 24h, 24h, 24h, 24h, 3ch, 18h,0,0     ;p
        db       18h, 3ch, 24h, 24h, 24h, 24h, 24h, 3fh, 3fh, 21h,0,0     ;q
        db       20h, 22h, 3eh, 3eh, 22h, 22h, 22h, 20h, 20h, 20h,0,0     ;r
        db       12h, 32h, 2ah, 2ah, 2ah, 2ah, 2ah, 2ah, 2eh, 24h,0,0     ;s
        db       20h, 20h, 20h,0fch,0feh, 22h, 22h, 22h,  2 ,  2 ,0,0     ;t
        db       3ch, 3eh,  2 ,  2 ,  2 ,  2 ,  2 ,  2 , 3eh, 3ch,0,0     ;u
        db        0 , 30h, 38h, 0ch,  6 ,  2 ,  6 , 0ch, 38h, 30h,0,0     ;v
        db       3ch, 3eh,  2 ,  2 , 1eh, 1eh,  2 ,  2 , 3eh, 3ch,0,0     ;w
        db        0 , 22h, 22h, 14h, 14h,  8 , 14h, 14h, 22h, 22h,0,0     ;x
        db       39h, 3dh,  5 ,  5 ,  5 ,  5 ,  5 ,  5 , 3fh, 3eh,0,0     ;y
        db       22h, 26h, 26h, 2eh, 2eh, 3ah, 3ah, 32h, 32h, 22h,0,0     ;z
        db        0 , 10h, 10h, 10h, 7ch,0eeh, 82h, 82h, 82h,  0 ,0,0     ;{
        db        0 ,  0 ,  0 ,  0 ,0eeh,0eeh,  0 ,  0 ,  0 ,  0 ,0,0     ;|
        db        0 , 82h, 82h, 82h,0eeh, 7ch, 10h, 10h, 10h,  0 ,0,0     ;{
        db       20h, 40h,0c0h, 80h,0c0h, 60h, 20h, 60h, 40h, 80h,0,0     ;~
        db        0 , 0eh, 1eh, 32h, 62h, 32h, 1eh, 0eh,  0 ,  0 ,0,0     ;
        db      01eh,03eh,068h,0c8h,088h,088h,0c8h,068h,03eh,01eh,0,0     ;
        db      082h,0feh,0feh,092h,092h,092h,092h,092h,09eh,09eh,0,0     ;
        db      082h,0feh,0feh,092h,092h,092h,092h,0f2h,07eh, 0ch,0,0     ;
        db      082h,0feh,0feh,082h,080h,080h,080h,080h,0c0h,0c0h,0,0     ;
        db        3 ,  3 ,03eh,07eh,0c2h,082h,082h,0feh,07fh,  3 ,0,0     ;
        db      082h,0feh,0feh,092h,092h,092h,092h,082h,0c6h,0c6h,0,0     ;
        db      0c6h,0eeh,038h,010h,0feh,0feh,010h,038h,0eeh,0c6h,0,0     ;
        db        4 ,046h,0c2h,092h,092h,092h,092h,0feh,0eeh,06ch,0,0     ;
        db      0feh,0feh,  2 , 0ch,018h,030h,060h,040h,0feh,0feh,0,0     ;
        db      0feh,0feh,  2 ,08ch,098h,0b0h,060h,040h,0feh,0feh,0,0     ;
        db      082h,0feh,0feh,010h,030h,038h,048h,0cch,086h,  6 ,0,0     ;K
        db        6 ,  2 ,  6 ,01ch,038h,060h,0c0h,080h,0feh,0feh,0,0     ;
        db      0feh,0feh,060h,030h,01ch,01ch,030h,060h,0feh,0feh,0,0     ;
        db      0feh,0feh,010h,010h,010h,010h,010h,010h,0feh,0feh,0,0     ;
        db      07ch,0feh,082h,082h,082h,082h,082h,082h,0feh,07ch,0,0     ;
        db      0feh,0feh,080h,080h,080h,080h,080h,080h,0feh,0feh,0,0     ;
        db      082h,0feh,0feh,092h,090h,090h,090h,090h,0f0h,070h,0,0     ;P
        db      07ch,0feh,082h,082h,082h,082h,082h,0c6h,044h,044h,0,0     ;
        db      0c0h,080h,080h,082h,0feh,0feh,082h,080h,080h,0c0h,0,0     ;T
        db      0e2h,0f2h,012h,012h,012h,012h,012h,016h,0feh,0fch,0,0     ;
        db      03ch,07eh,062h,042h,0ffh,0ffh,042h,062h,07eh,03ch,0,0     ;
        db      082h,082h,0c6h,048h,030h,030h,048h,0c6h,082h,082h,0,0     ;
        db      0fch,0feh,  2 ,  2 ,  2 ,  2 ,0feh,0feh,  3 ,  3 ,0,0     ;
        db      0e0h,0f0h,030h,010h,010h,010h,010h,010h,0feh,0feh,0,0     ;
        db      0feh,0feh,  2 ,  2 ,0feh,0feh,  2 ,  2 ,0feh,0feh,0,0     ;
        db      0feh,0feh,  2 ,  2 ,0feh,0feh,  2 ,  2 ,0ffh,0ffh,0,0     ;
        db      080h,080h,0feh,0feh,012h,012h,012h,01ah, 0ch, 0ch,0,0     ;
        db      0feh,0feh,012h,012h,012h,01ah, 0ch,  0 ,0feh,0feh,0,0     ;
        db      0feh,0feh,012h,012h,012h,012h,012h,01ah, 0ch, 0ch,0,0     ;
        db      082h,082h,092h,092h,092h,092h,054h,054h,038h,038h,0,0     ;
        db      0feh,0feh,010h,010h,07ch,0feh,0c6h,0c6h,0feh,07ch,0,0     ;
        db        2 ,  2 ,066h,0f4h,094h,098h,098h,090h,0feh,0feh,0,0     ;
        db      02eh,02eh,02ah,02ah,02ah,02ah,02ah,03eh,03eh,  2h,0,0     ;
        db        2h, 22h, 3eh, 3eh, 2ah, 2ah, 2ah, 2ah, 2eh, 24h,0,0     ;
        db        2h, 22h, 3eh, 3eh, 2ah, 2ah, 3ah, 1ah, 0eh, 04h,0,0     ;
        db        2 , 22h, 3eh, 3eh, 22h, 20h, 20h, 20h, 30h,  0 ,0,0     ;
        db        3 ,  3 , 1eh, 3eh, 22h, 22h, 3eh, 1eh,  3 ,  3 ,0,0     ;
        db       1ch,03eh, 2ah, 2ah, 2ah, 2ah, 2ah, 2ah, 3ah, 1ah,0,0     ;
        db       36h, 36h, 0ch, 0ch, 3eh, 3eh, 0ch, 0ch, 36h, 36h,0,0     ;
        db       14h, 22h, 22h, 22h, 2ah, 2ah, 2Ah, 2ah, 3eh, 14h,0,0     ;
        db       3eh, 3eh,  2 ,  6 , 0ch, 18h, 30h, 20h, 3eh, 3eh,0,0     ;
        db       3eh, 3eh,  2 , 86h, 8ch, 98h,0b0h, 20h, 3eh, 3eh,0,0     ;
        db       82h, 82h,0feh,07eh,  8 ,  8 , 14h, 14h, 22h, 22h,0,0     ;
        db        0 ,  6 , 0eh, 18h, 30h, 20h, 30h, 18h, 0eh,  6 ,0,0     ;
        db       3eh, 3eh, 10h,  8 ,  4 ,  4 ,  8 , 10h, 3eh, 3eh,0,0     ;
        db        0 , 3eh, 3eh,  8 ,  8 ,  8 ,  8 ,  8 , 3eh, 3eh,0,0     ;
        db       1ch, 3eh, 22h, 22h, 22h, 22h, 22h, 22h, 3eh, 1ch,0,0     ;
        db       3eh, 3eh, 20h, 20h, 20h, 20h, 20h, 20h, 3eh, 3eh,0,0     ;
        db       21h,03fh,03fh, 24h, 24h, 24h, 24h, 24h, 3ch, 18h,0,0     ;
        db       1ch,03eh, 22h, 22h, 22h, 22h, 22h, 22h, 22h, 36h,0,0     ;
        db       1eh, 3eh, 20h, 20h, 3eh, 3eh, 20h, 20h, 3eh, 3eh,0,0     ;
        db       39h, 3dh,  5 ,  5 ,  5 ,  5 ,  5 ,  5 , 3fh, 3eh,0,0     ;
        db       0ch, 1eh, 12h, 12h, 3fh, 3fh, 12h, 12h, 1eh, 0ch,0,0     ;
        db        0 , 22h, 22h, 14h, 14h,  8 , 14h, 14h, 22h, 22h,0,0     ;
        db       3eh, 3eh,  2 ,  2 ,  2 ,  2 , 3eh, 3eh,  3 ,  3 ,0,0     ;
        db        0 , 30h, 38h,  8 ,  8 ,  8 ,  8 ,  8 , 3eh, 3eh,0,0     ;
        db       3eh, 3eh,  2 ,  2 , 3eh, 3eh,  2 ,  2 , 3eh, 3eh,0,0     ;
        db       3eh, 3eh,  2 ,  2 , 3eh, 3eh,  2 ,  2 , 3fh, 3fh,0,0     ;
        db       20h, 20h, 3eh, 3eh, 0ah, 0ah, 0ah, 0ah, 0eh,  4 ,0,0     ;
        db       3eh, 3eh, 0ah, 0ah, 0eh, 0eh,  4 ,  0 , 3eh, 3eh,0,0     ;
        db        0 , 3eh, 3eh, 0ah, 0ah, 0ah, 0ah, 0ah, 0eh,  4 ,0,0     ;
        db        0 , 22h, 22h, 2ah, 2ah, 2ah, 2ah, 3eh, 1ch, 1ch,0,0     ;
        db       3eh, 3eh,  8 ,  8 , 1ch, 3eh, 22h, 22h, 3eh, 1ch,0,0     ;
        db        0 , 10h, 3ah, 2ah, 2ah, 2ch, 2ch, 28h, 3eh, 3eh,0,0     ;
        db    000h,000h,000h,000h,000h,0f8h,0f8h,008h,008h,008h,008h,008h ;
        db    008h,008h,008h,008h,008h,0f8h,0f8h,008h,008h,008h,008h,008h ;
        db    008h,008h,008h,008h,008h,00fh,00fh,008h,008h,008h,008h,008h ;
        db    000h,000h,000h,000h,000h,0ffh,0ffh,008h,008h,008h,008h,008h ;
        db    008h,008h,008h,008h,008h,008h,008h,008h,008h,008h,008h,008h ;
        db    008h,008h,008h,008h,008h,0ffh,0ffh,008h,008h,008h,008h,008h ;
        db    014h,014h,014h,0f7h,0f7h,000h,000h,0ffh,0ffh,000h,000h,000h ;
        db    000h,000h,000h,0ffh,0ffh,000h,000h,0ffh,0ffh,000h,000h,000h ;
        db    000h,000h,000h,0fch,0fch,004h,004h,0f4h,0f4h,014h,014h,014h ;
        db    000h,000h,000h,01fh,01fh,010h,010h,017h,017h,014h,014h,014h ;
        db    014h,014h,014h,0f4h,0f4h,004h,004h,0f4h,0f4h,014h,014h,014h ;
        db    014h,014h,014h,017h,017h,010h,010h,017h,017h,014h,014h,014h ;
        db    000h,000h,000h,0ffh,0ffh,000h,000h,0f7h,0f7h,014h,014h,014h ;
        db    014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h,014h ;
        db    014h,014h,014h,0f7h,0f7h,000h,000h,0f7h,0f7h,014h,014h,014h ;
        db    008h,008h,008h,008h,008h,00fh,00fh,000h,000h,000h,000h,000h ;
        db    055h,000h,000h,000h,055h,000h,000h,000h,055h,000h,000h,000h ;
        db    055h,000h,000h,0aah,000h,000h,055h,000h,000h,0aah,000h,000h ;
        db    055h,000h,0aah,000h,055h,000h,0aah,000h,055h,000h,0aah,000h ;
        db    000h,000h,000h,000h,000h,0ffh,0ffh,000h,000h,000h,000h,000h ;
        db    008h,008h,008h,008h,008h,0ffh,0ffh,000h,000h,000h,000h,000h ;
        db    0feh,0feh,060h,030h,018h,00ch,0feh,080h,0beh,0a2h,0beh,000h ;
        db    000h,0fah,0fah,0aah,0aah,0aah,0aah,0beh,0beh,000h,000h,000h ;
        db    014h,014h,014h,017h,017h,010h,010h,01fh,01fh,000h,000h,000h ;
        db    014h,014h,014h,0f4h,0f4h,004h,004h,0fch,0fch,000h,000h,000h ;
        db    008h,008h,008h,008h,008h,0f8h,0f8h,000h,000h,000h,000h,000h ;
        db    000h,000h,000h,000h,000h,00fh,00fh,008h,008h,008h,008h,008h ;
        db    0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh ;
        db    00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh ;
        db    0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,000h,000h,000h,000h,000h,000h ;
        db    000h,000h,000h,000h,000h,000h,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh ;
        db    0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h,0f0h ;
        db    01ch,03eh,022h,022h,022h,03eh,01ch,008h,014h,022h,000h,000h ;
        db    001h,003h,03eh,03eh,02ah,02ah,03ah,01ah,00eh,004h,000h,000h ;
        db    002h,082h,0feh,0feh,082h,082h,080h,080h,0c0h,0e0h,000h,000h ;
        db    020h,020h,03eh,03eh,020h,020h,03eh,03eh,020h,020h,000h,000h ;
        db    082h,0c6h,0c6h,0aah,0aah,092h,082h,082h,0c6h,0c6h,000h,000h ;
        db    01ch,03eh,022h,022h,022h,022h,03eh,03ch,020h,020h,000h,000h ;
        db    003h,003h,03eh,03ch,00ch,004h,002h,004h,03eh,03eh,000h,000h ;
        db    010h,030h,020h,020h,03eh,03eh,020h,020h,020h,020h,000h,000h ;
        db    000h,000h,0bah,0bah,0eeh,0eeh,0bah,0bah,000h,000h,000h,000h ;
        db    038h,07ch,0feh,092h,092h,092h,092h,0feh,07ch,038h,000h,000h ;
        db    032h,07ah,04ah,044h,040h,040h,044h,04ah,07ah,032h,000h,000h ;
        db    000h,00ch,01eh,0d2h,0d2h,092h,092h,05eh,00ch,000h,000h,000h ;
        db    010h,028h,028h,028h,010h,010h,028h,028h,028h,010h,000h,000h ;
        db    000h,000h,03ah,03ch,028h,038h,028h,078h,0b8h,000h,000h,000h ;
        db    038h,038h,054h,054h,092h,092h,092h,092h,082h,082h,000h,000h ;
        db    07eh,0feh,080h,080h,080h,080h,080h,080h,0feh,07eh,000h,000h ;
        db    092h,092h,092h,092h,092h,092h,092h,092h,092h,092h,000h,000h ;
        db    000h,022h,022h,022h,0fah,0fah,022h,022h,022h,000h,000h,000h ;
        db    000h,002h,022h,022h,052h,052h,08ah,08ah,002h,000h,000h,000h ;
        db    000h,002h,08ah,08ah,052h,052h,022h,022h,002h,000h,000h,000h ;
        db    000h,000h,000h,000h,07fh,0ffh,080h,080h,0c0h,040h,000h,000h ;
        db    004h,006h,002h,002h,0feh,0fch,000h,000h,000h,000h,000h,000h ;
        db    000h,010h,010h,010h,092h,0d6h,092h,010h,010h,010h,000h,000h ;
        db    022h,044h,0cch,088h,0cch,066h,022h,066h,044h,088h,000h,000h ;
        db    000h,000h,000h,060h,0f0h,090h,090h,0f0h,060h,000h,000h,000h ;
        db    000h,000h,000h,000h,018h,018h,018h,018h,000h,000h,000h,000h ;
        db    000h,000h,000h,000h,000h,010h,010h,000h,000h,000h,000h,000h ;
        db    008h,004h,004h,002h,002h,0ffh,0ffh,080h,080h,080h,000h,000h ;
        db    000h,080h,0f0h,070h,080h,080h,080h,080h,0f0h,070h,000h,000h ;
        db    000h,000h,058h,098h,098h,0a8h,0a8h,0e8h,048h,000h,000h,000h ;
        db    000h,000h,03ch,03ch,03ch,03ch,03ch,03ch,000h,000h,000h,000h ;
        db    000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h ;


I2F_Handler     proc    far                    ;Int 2Fh handler.
                cmp     ax,UniqueCode_F1
                jne     HInt2F_3
                xchg    ah,al               ;Function1: Check for instalation.
                iret                        ;Exchange ah and al if installed.
        HInt2F_3:
                cmp     ax,UniqueCode_F2
                jne     HInt2F_2
                mov     ax,cs               ;Function2: Return code segment of
                iret                        ; resident TSR.
        HInt2F_2:
                jmp     dword ptr cs:[OldInt2F]
I2F_Handler     endp

; End resident part 
;
End_Resident:
                mov     ax,UniqueCode_F1                ;Is TSR instaled ?
                mov     bx,ax
                int     2fh
                xchg    bh,bl
                cmp     ax,bx
                jne     Main_2
                jmp     Main_Uninstall                 ;-->already instaled.
        Main_2:
                mov     ax,352fh
                int     21h                             ;Get vectors
                mov     word ptr OldInt2F,bx            ; int 2fh
                mov     word ptr [OldInt2F+2],es
                mov     ax,3517h
                int     21h
                mov     word ptr OldInt17,bx            ; int 17h
                mov     word ptr [OldInt17+2],es

                push    ds
                pop     es

                mov     dx,offset I2F_Handler           ; Set vectors
                mov     ax,252fh                        ; int   2Fh
                int     21h
                mov     dx,offset I17_Handler
                mov     ax,2517h                        ; int   17h
                int     21h

                mov     dx,offset Msg_Ins               ;Display Mesage.
                mov     ah,9
                int     21h

                mov     dx,offset End_Resident
                add     dx,15
                shr     dx,4                            ; Stay resident and
                mov     ax,3100h                        ; terminate program.
                int     21h

        Main_Uninstall:
                mov     ax,UniqueCode_F2               ; Get curent code
                int     2fh                            ; segment.
                mov     bx,ax                          ;In BX TSR_Prog_Seg

                push    ds                             ; Check if handlers are
                mov     ax,0                           ; upper. (TSR is trapped)
                mov     ds,ax
                cmp     bx,word ptr ds:[17h*4+2]
                jne     Main_4
                cmp     bx,word ptr ds:[2fh*4+2]
                jne     Main_4
                pop     ds
                jmp     Main_3
        Main_4:                                     ;TSR cann't be uninstaled.
                pop     ds                          ;Display message
                mov     dx,offset Msg_CanntUn
                mov     ah,9
                int     21h
                jmp     Un_Go_Dos                   ;go to dos
        Main_3:
                mov     dx,offset Msg_UnIns
                mov     ah,9
                int     21h
                                                       ;Restore old handlers.
                mov     es,bx
                mov     dx,word ptr es:OldInt2F        ; Set vectors
                mov     ds,word ptr es:[OldInt2F+2]
                mov     ax,252fh                        ; int   2Fh
                int     21h
                mov     dx,word ptr es:OldInt17
                mov     ds,word ptr es:[OldInt17+2]
                mov     ax,2517h                        ; int   17h
                int     21h

                mov     ds,bx                           ;Free environment mem
                mov     es,word ptr ds:[2ch]
                mov     ah,49h
                int     21h
                mov     es,bx                           ;Free resident part
                mov     ah,49h
                int     21h
        Un_Go_Dos:
                mov     ah,4ch                          ;Exit to dos
                int     21h

Msg_UnIns       db      'CyrPrn uninstalled.$'
Msg_Ins         db      10,13,'DOS cyrillic for printer instaled.',10,13
                db      'To uninstal cyrillic for printer, start CyrPrn.com again.$'
Msg_CanntUn     db      'CyrPrn.com can not be uninstalled.',10,13
                db      'You must remove another TSRs first.$'
;_______________________________________________________________________DATA___
code    ends
        end     Start

